<script setup lang="ts">
import { ref } from "vue";
import { getToken, getDecodedToken, getCurrentEmployerId } from '../utils/token-utils';
import Intervention from "../types/intervention";
import User from "../types/user";
import Status from "../types/status";

// Récupération des droits :
const token = getToken() ?? "";
const decodedToken = getDecodedToken(token);
const currentEmployerId = getCurrentEmployerId(decodedToken);

const { baseURL }: { baseURL: string } = useRuntimeConfig().app;
const { id } = useRoute().params;
const authorizationHeader = useAuthorizationHeader("application/json");
const patchAuthorizationHeader = useAuthorizationHeader(
  "application/merge-patch+json"
);

// Appel API
const { data: intervention } = await useFetch<Intervention>(
  baseURL + "api/interventions/" + id,
  {
    headers: authorizationHeader,
  }
);

const { data: participants } = await useFetch<User>(
  baseURL + `api/employers/${currentEmployerId}/active-agents`,
  {
    headers: authorizationHeader,
  }
);

let showModalAssignation = ref(false);
let showModalAttente = ref(false);
let showModalSupprimer = ref(false);

defineProps({
  showMenu: Boolean,
});

const useGeolocation = () => {
  if (navigator.geolocation) {
    navigator.geolocation.getCurrentPosition(
      (position) => {
        // Récupérer la latitude et la longitude de l'objet intervention
        const latitude = intervention.value.location.latitude;
        const longitude = intervention.value.location.longitude;

        processGeolocationCoordinates(latitude, longitude);
      },
      (error) => {
        // Gérer les erreurs de géolocalisation
        console.error("Erreur de géolocalisation : ", error);
      }
    );
  }
};

function processGeolocationCoordinates(latitude: number, longitude: number) {
  // Générer le lien vers le GPS du téléphone avec les coordonnées de l'intervention
  const gpsLink = `geo:${latitude},${longitude}`;

  // Ouvrir le GPS du téléphone
  window.location.href = gpsLink;
}

const selectedParticipants = ref({
  participants: [],
});

async function assigneParticipants(id: number) {
  try {
    const updateData: { participants?: string[]; status?: string } = {};
    if (
      selectedParticipants.value.participants &&
      selectedParticipants.value.participants.length > 0
    ) {
      updateData.participants = selectedParticipants.value.participants;
      updateData.status = "/status/to-do";
    }
    if (Object.keys(updateData).length > 0) {
      await $fetch<Intervention>(`${baseURL}api/interventions/${id}`, {
        method: "PATCH",
        headers: patchAuthorizationHeader,
        body: updateData,
      });
      showModalAssignation.value = false;
      location.reload();
    }
  } catch (error) {
    console.error(error);
  }
}

async function changeStatus(id: number) {
  try {
    const response = await $fetch<Status>(`${baseURL}api/interventions/${id}`, {
      method: "PATCH",
      headers: patchAuthorizationHeader,
      body: JSON.stringify({
        status: `/status/blocked`,
      }),
    });

    window.location.href = `/interventions/${id}/attente`;
    // Traiter la réponse si nécessaire
  } catch (error) {
    console.error(error);
  }
}

async function deleteIntervention(id: number) {
  try {
    await $fetch<Intervention>(`${baseURL}api/interventions/${id}`, {
      method: "DELETE",
      headers: authorizationHeader,
    });
    alert("L'intervention a bien été suprimée");
    window.location.href = "/";
  } catch (error) {
    console.error("Erreur lors de la suppression de l'intervention", error);
  }
}
</script>

<template>
  <div class="fr-grid-row fr-grid-row--middle sub-header">
    <a class="fr-icon-arrow-left-line fr-p-1w" href="/"></a>

    <slot></slot>

    <button
      class="fr-icon-more-fill fr-p-1w button-menu"
      @click="showMenu = !showMenu"
      @click.stop
    ></button>

    <div class="modal-menu-background" v-if="showMenu == true">
      <ul>
        <li
          class="fr-p-2w fr-nav__item"
          v-if="decodedToken.roles.includes('ROLE_DIRECTOR')"
        >
          <a :href="`/interventions/${id}/modification`"> Modifier </a>
        </li>
        <li
          class="fr-p-2w fr-nav__item"
          v-if="
            decodedToken.roles.includes('ROLE_ADD_PARTICIPANTS_TO_INTERVENTION')
          "
          @click="showModalAssignation = true"
        >
          Assigner
        </li>
        <Modal
          :show="showModalAssignation"
          @close="showModalAssignation = false"
        >
          <div class="fr-mx-2w">
            <h3 class="fr-pb-2w fr-icon-arrow-right-line">
              Qui voulez-vous assigner à cette mission ?
            </h3>
            <div class="fr-form-group">
              <fieldset class="fr-fieldset">
                <div class="fr-fieldset__content">
                  <div class="fr-checkbox-group" v-for="part in participants">
                    <input
                      type="checkbox"
                      :id="`checkboxes-${part.id}`"
                      name="checkboxes"
                      :value="`/users/${part.id}`"
                      v-model="selectedParticipants.participants"
                    />
                    <label class="fr-label" :for="`checkboxes-${part.id}`">
                      {{ part.firstname }} {{ part.lastname }}
                    </label>
                  </div>
                </div>
              </fieldset>
            </div>
          </div>
          <ul class="fr-btns-group fr-mx-2w">
            <li>
              <a
                href="#"
                class="fr-btn fr-grid-row--center"
                @click.prevent="assigneParticipants(id)"
              >
                Valider
              </a>
            </li>
            <li>
              <button
                class="fr-btn fr-btn--secondary fr-grid-row--center"
                @click="showModalAssignation = false"
              >
                Annuler
              </button>
            </li>
          </ul>
        </Modal>
        <li class="fr-p-2w fr-nav__item" @click="showModalAttente = true">
          Mise en attente
        </li>
        <Modal :show="showModalAttente" @close="showModalAttente = false">
          <div class="fr-mx-2w">
            <h2 class="fr-icon-arrow-right-line">Mettre en attente</h2>
            <p class="fr-pb-2w">
              Vous vous apprêtez à mettre en attente cette intervention.
            </p>
          </div>
          <ul class="fr-btns-group fr-mx-2w">
            <li>
              <button
                class="fr-btn fr-grid-row--center"
                @click.prevent="changeStatus(id)"
              >
                Valider
              </button>
            </li>
            <li>
              <button
                class="fr-btn fr-btn--secondary fr-grid-row--center"
                @click="showModalAttente = false"
              >
                Annuler
              </button>
            </li>
          </ul>
        </Modal>
        <li class="fr-p-2w fr-nav__item" @click="useGeolocation">Itinéraire</li>
        <li
          class="fr-p-2w fr-nav__item nav-delete"
          v-if="decodedToken.roles.includes('ROLE_DELETE_INTERVENTION')"
          @click="showModalSupprimer = true"
        >
          Supprimer
        </li>
        <Modal :show="showModalSupprimer" @close="showModalSupprimer = false">
          <div class="fr-mx-2w">
            <h2 class="fr-icon-arrow-right-line">Suppression</h2>
            <p class="fr-pb-2w">
              Vous vous apprêtez à supprimer l'intervention.
            </p>
          </div>
          <ul class="fr-btns-group fr-mx-2w">
            <li>
              <button
                class="fr-btn fr-grid-row--center"
                @click.prevent="deleteIntervention(id)"
              >
                Valider
              </button>
            </li>
            <li>
              <button
                class="fr-btn fr-btn--secondary fr-grid-row--center"
                @click="showModalSupprimer = false"
              >
                Annuler
              </button>
            </li>
          </ul>
        </Modal>
        <li class="fr-link--close fr-link" @click="showMenu = false">Fermer</li>
      </ul>
    </div>
  </div>
</template>

<style scoped>
a {
  background-image: none;
}

.sub-header {
  justify-content: space-between;
}

.button-menu {
  transform: rotate(90deg);
}

.modal-menu-background {
  position: fixed;
  right: 22px;
  top: 50px;
  background-color: white;
  z-index: 999;
}

.modal-menu-background li {
  font-size: 12px;
}

.nav-delete {
  color: red;
}
</style>
